<template>
    <div
        class="box-notification relative"
        :class="{ active: isActiveMenuNotification }"
    >
        <div
            @click="onToggleMenuChat"
            class="w-7 h-7 cursor-pointer"
            v-tooltip:bottom="'Thông báo'"
        >
            <BellIcon class="h-7 w-7 mx-auto" />
        </div>
        <div
            class="drop-down-list absolute bg-white shadow-card border rounded-md"
        >
            <div class="p-3 text-2xl font-bold border-b">Thông báo</div>

            <!-- start list notification -->
            <ul
                @scroll="onScroll"
                class="list-notification-header max-h-box-header overflow-y-auto divide-y"
            >
                <template v-if="!isLoading && !notifications.length">
                    <li class="text-center p-3">Không có tin thông báo nào</li>
                </template>
                <template v-else-if="!isLoading">
                    <li
                        @click="onClickItemNotification"
                        :key="notification.id"
                        v-for="notification in notifications"
                    >
                        <ItemNotification :notification="notification" />
                    </li>
                    <template v-if="!isLastPage">
                        <li :key="n" v-for="n in 2">
                            <ItemNotificationSkeleton />
                        </li>
                    </template>
                </template>
                <template v-else>
                    <li :key="n" v-for="n in 5">
                        <ItemNotificationSkeleton />
                    </li>
                </template>
            </ul>
            <!-- end list notification -->

            <div class="p-2 text-center border-t">
                <router-link
                    :to="{ name: 'test', params: {} }"
                    @click="onClickItemNotification"
                    class="inline-block text-main-color hover:underline"
                >
                    Xem tất cả
                </router-link>
            </div>
        </div>
    </div>
</template>

<script>
import { onMounted, ref } from "vue";

import useFetchAllNotification from "@/hooks/notification/useFetchAllNotification";

import { BellIcon } from "@heroicons/vue/outline";
import ItemNotification from "@/components/notification/ItemNotification.vue";
import ItemNotificationSkeleton from "@/components/notification/ItemNotificationSkeleton.vue";

export default {
    components: {
        BellIcon,
        ItemNotification,
        ItemNotificationSkeleton
    },
    setup() {
        const isActiveMenuNotification = ref(false);
        const notifications = ref([]);
        const {
            isLoading,
            listNotification,
            onFetchAllNotification
        } = useFetchAllNotification();
        const isLastPage = ref(false);

        async function onToggleMenuChat() {
            isActiveMenuNotification.value = !isActiveMenuNotification.value;
            // nếu chưa hết notif và list notif mở thì load data
            if (!notifications.value.length && isActiveMenuNotification.value) {
                await onFetchAllNotification();
                notifications.value = [
                    ...notifications.value,
                    ...listNotification.value.data
                ];
                // check last page
                if (
                    listNotification.value.current_page ===
                    listNotification.value.last_page
                ) {
                    isLastPage.value = true;
                }
            }
        }

        async function onClickItemNotification() {
            isActiveMenuNotification.value = false;
        }

        // close box notif when window click
        document.addEventListener("click", function(e) {
            if (!e.target.closest(".box-notification")) {
                onClickItemNotification();
            }
        });

        // list notification scroll
        onMounted(() => {
            // const listEvent = document.getElementsByClassName(
            //     "list-notification-header"
            // )[0];
            // listEvent.addEventListener("scroll", async function() {
            //     // check last page
            //     if (
            //         listNotification.value.current_page ===
            //         listNotification.value.last_page
            //     ) {
            //         isLastPage.value = true;
            //     }
            //     const scrollPercent = Math.round(
            //         (listEvent.scrollTop /
            //             (listEvent.scrollHeight - listEvent.clientHeight)) *
            //             100
            //     );
            //     if (scrollPercent === 100) {
            //         const next_page = listNotification.value.current_page + 1;
            //         if (next_page <= listNotification.value.last_page) {
            //             await onFetchAllNotification(
            //                 listNotification.value.current_page + 1
            //             );
            //             notifications.value = [
            //                 ...notifications.value,
            //                 ...listNotification.value.data
            //             ];
            //         }
            //     }
            // });
        });

        async function onScroll(e) {
            if (
                listNotification.value.current_page ===
                listNotification.value.last_page
            ) {
                isLastPage.value = true;
            }

            const scrollTop = Math.round(e.target.scrollTop);
            const height = Math.round(
                e.target.scrollHeight - e.target.clientHeight
            );

            if (scrollTop === height) {
                const next_page = listNotification.value.current_page + 1;
                if (next_page <= listNotification.value.last_page) {
                    await onFetchAllNotification(
                        listNotification.value.current_page + 1
                    );
                    notifications.value = [
                        ...notifications.value,
                        ...listNotification.value.data
                    ];
                }
            }
        }

        return {
            isActiveMenuNotification,
            onToggleMenuChat,
            onClickItemNotification,
            notifications,
            isLoading,
            isLastPage,
            onScroll
        };
    }
};
</script>

<style lang="scss" scoped>
.box-notification {
    &.active .drop-down-list {
        pointer-events: all;
        opacity: 1;
        z-index: 9999;
    }
    .drop-down-list {
        top: 35px;
        right: 0;
        width: 350px;
        pointer-events: none;
        opacity: 0;
        z-index: -1;
        ul li a {
            transition: all ease-in-out 0.1s;
            &:hover {
                @apply bg-main-color-hover-header-2;
            }
        }
    }
}
p {
    display: inline-block;
}
</style>
